#ifndef _RXVECDSPLINE_H_WRAP_
#define _RXVECDSPLINE_H_WRAP_

#include <RxVecdN.h>
#include <RxDlist.h>

class RxVecdNSknot : public RxDlistNode
{
	friend class RxVecdNSpline;

	RxVecdN *v;
	double u;
	double w;
	RX_DLIST_NODE (RxVecdNSknot);
};

RX_DLIST_CLASS (RxVecdNSknotList, RxVecdNSknot);

class RxVecdNSpline
{

    private:
	int degree;
	int rational;

	RxVecdNSknotList knots;
	int numk;
	int vlen;

	void deBoor (RxVecdN *v, RxVecdNSknot *k0, 
				 RxVecdNSknot *k1, double u, int k);
	RxVecdNSknot *findBaseKnot (double u);
	RxVecdNSknot *lastBaseKnot;
	RxVecdNSknot *curPnt;

    public:
	RxVecdNSpline (int len, int deg, int rat);

	void reset ();
	void reset (int deg, int rat);

	int addPnt (RxVecdN *v, double u);
	int addPnt (RxVecdN *v, double w, double u);
	int removePnts (double u);
	int calc (RxVecdN *v, double u);

	int getDegree()
	 { return (degree);
	 }
	int isRational()
	 { return (rational ? 1 : 0);
	 }
	int numKnots ()
	 { return numk;
	 }
	RxVecdN *firstPnt (double *u, double *w);
	RxVecdN *firstPnt ()
	 { return (firstPnt ((double*)0, (double*)0));
	 }
	RxVecdN *nextPnt (double *u, double *w);
	RxVecdN *nextPnt ()
	 { return (nextPnt ((double*)0, (double*)0));
	 }
};

#endif
