#ifndef _RXCYLINDER_H_WRAP_
#define _RXCYLINDER_H_WRAP_

#include <RxPrism.h>

#define RXCYLINDER_DEFAULT_NUM_SIDES 8

class RxCylinder : public RxPrism
{
protected:
	double radtop;
	double radbot;
	void init();
public:
	static const int ID;
	static const int DEFAULT_NUM_SIDES;

	RxCylinder() : RxPrism()
	 { init();
	 }
	RxCylinder(double len, double rtop, double rbot, 
	      int nsides=DEFAULT_NUM_SIDES) : RxPrism()
	 { init();
	   set (len, rtop, rbot, nsides);
	 }
	
	void set (double len, double rtop, double rbot, 
		  int nsides=DEFAULT_NUM_SIDES);

	double radius()
	 { return radtop;
	 }
	double bottomRadius()
	 { return radbot;
	 }
	double length()
	 { return len;
	 }
	int nsides()
	 { return nsides_;
	 }

	virtual int oscan (class RxParseObj *obj);
	virtual int cprint (class RxCoutput *co, class RxPrintSpec *ps) const;
};

#endif
