#ifndef _RXDHLINK_H_WRAP_
#define _RXDHLINK_H_WRAP_

#include <RxLink.h>

class RxDHLink : public RxLink
{
protected:
	double alpha_;
	double theta_;
	double a_;
	double d_;
	double ct, st;
	double ca, sa;
public:
	void copy (const RxDHLink &link);

	void setParams (double d, double theta, double a, double alpha);
	void getParams (double *dp, double *thetap, double *ap,
			double *alphap) const;

	RxDHLink ()
	 { theta_ = 0;
	   a_ = 0;
	   alpha_ = 0;
	   A_.setIdent();
	 }
	RxDHLink (double d, double theta, double a, double alpha)
	 { setParams (d, theta, a, alpha);
	 }

	virtual int oscan (class RxParseObj *obj);
	virtual int cprint(class RxCoutput *co,class RxPrintSpec *ps) const;
};

#endif

