#ifndef _RXFEATUREHASHTAB_H_WRAP_
#define _RXFEATUREHASHTAB_H_WRAP_

#include <RxCvxPrim3.h>
#include <RxSolidType3.h>
#include <RxHashTab.h>

class RxFeatureHashNode : public RxHashNodeBase
{
    public:
	RxSolidType3Pair primpair;
	RxCvxPrim3Pair featpair;
	RxFeatureHashNode (const RxSolidType3Pair *p, 
			   const RxCvxPrim3Pair *f)
	 { primpair = *p;
	   featpair = *f;
	 }
	int match (void *p) const
	 { RxSolidType3Pair *pp = (RxSolidType3Pair *)p;
	   return (pp->obj[0] == primpair.obj[0] &&
		   pp->obj[1] == primpair.obj[1]);
	 }
};

class RxFeatureHashTab : public RxHashTabBase
{
public:
	RxFeatureHashTab(int size=3001) : RxHashTabBase(size)
	 {
	 }
	int hash(const RxSolidType3Pair *ptp) const
	 { return ((unsigned int)ptp->obj[0]
		   ^ (((unsigned int) ptp->obj[1]) << 16)
		   ^ (((unsigned int) ptp->obj[1]) << 16)) % size_;
	 }
	RxFeatureHashNode *getQ(const RxSolidType3Pair *prims,
				const RxCvxPrim3Pair *feats);
	RX_HASH_TAB_DEFS (RxFeatureHashNode, const RxSolidType3Pair *,
			  const RxCvxPrim3Pair *);
};

#endif
