#ifndef _RXPLANE3_H_WRAP_
#define _RXPLANE3_H_WRAP_

#include <RxVecd3.h>
#include <iostream.h>
#include <RxPrintable.h>

class RxPlane3 : public RxPrintable
{
	RxVecd3 nrm_;   // plane = { p | < p , nrm_ > + off_ = 0 }
	double off_;
public:
	const RxVecd3 &n() const {return nrm_;}
	const double  &off() const {return off_;}

	void set(const RxVecd3 &nrm, const RxVecd3 &thruPoint)
	 { nrm_ = nrm; off_ = - thruPoint.dot(nrm);
	 }
	void set(const RxVecd3 &nrm, double off)
	 { nrm_ = nrm; off_ = off;
	 }

	RxPlane3 ()
	 {
	 }
	RxPlane3 (const RxVecd3 &nrm, const RxVecd3 &thruPoint)
	 { set (nrm, thruPoint);
	 }
	RxPlane3 (const RxVecd3 &nrm, double off)
	 { set (nrm, off);
	 }

	void normalize(const RxPlane3 &p1);
	void normalize()
	 { normalize (*this);
	 }
	void getTrsf (class RxTrsf *TP) const;

	// Compute signed distance from point to plane; 
	// assumes unit length nrm_

	double dist(const RxVecd3 &point) const 
	 { return nrm_.dot(point) + off_;
	 }

	virtual int oscan (class RxParseObj *obj);
	virtual int cprint(class RxCoutput *co,class RxPrintSpec *ps) const;
};

#endif
