#ifndef _RXPRINTABLE_H_WRAP_
#define _RXPRINTABLE_H_WRAP_

#include <iostream.h>
#include <stdio.h>

class RxPrintable
{
	// an abstract class that defines printing and scanning
	// interface functions.

public:
	int scan (FILE *fp=stdin);
	int xscan (FILE *fp);
	int scan (const char *buf, int *cntp=NULL);
	int scan (class RxCinput *ci);
	istream &scan (istream &is);
	
	int print (FILE *fp, const char *fmt) const;
	int print (const char *fmt) const
	 { return this->print(stdout, fmt);
	 }
	int print (char *buf, const char *fmt, int n=0) const;
	ostream &print (ostream &os) const;

	virtual int oscan (class RxParseObj *obj) = 0;
	virtual int cprint(class RxCoutput *co,class RxPrintSpec *ps) const=0;
};

inline ostream &operator<<(ostream &os, const RxPrintable &p)
{
	return p.print(os);
}

inline istream &operator>>(istream &is, RxPrintable &p)
{
	return p.scan(is);
}

#endif
