#ifndef _RXPRISMATICLINK_H_WRAP_
#define _RXPRISMATICLINK_H_WRAP_

#include <RxJoint.h>

class RxPrismaticJoint : public RxJoint
{
	double d_;

	virtual int oscanField (class RxParseObj *obj);
	virtual int checkFields (class RxParseObj *obj);
	virtual int cprintFields (class RxCoutput *co,class RxPrintSpec *ps,
				  int init=1) const;
	void init();
public:
	static const int ID;
	virtual const char *typeName() const
	 { return "PrismaticJoint";
	 }

	RxPrismaticJoint() : RxJoint(1,1)
	 { init();
	 }
	void setJnt (double d)
	 { d_ = d;
	 }
	double getJnt () const
	 { return d_;
	 }
	void setJnt (const RxVecd &vec, int j=0)
	 { d_ = vec(j);
	 }
	void getJnt (RxVecd &vec, int j=0) const
	 { vec(j) = d_;
	 }

	void getTrsf (RxTrsf &T) const;
	void postMulTrsf (RxTrsf &TR, const RxTrsf &T) const;
	void postMulTrsf (RxTrsf &T) const;
	void preMulTrsf (RxTrsf &TR, const RxTrsf &T) const;
	void preMulTrsf (RxTrsf &T) const;
	void addVel (RxTwist &vel) const;
	void addAcc (RxSpatialAccel &acc, const RxTwist &vel0,
				   const RxVecd &jacc, int j=0) const;
	double getJfor (const RxWrench &wr) const;
	void getJfor (RxVecd &jfor, const RxWrench &wr, int j=0) const
	 { jfor(j) = getJfor (wr);
	 }
	void getJcol (RxMatd *cols, const RxTrsf &U, int j=0) const;
};
#endif
