#ifndef _RXPRISMATICLINK_H_WRAP_
#define _RXPRISMATICLINK_H_WRAP_

#include <RxDHLink.h>

class RxPrismaticLink : public RxDHLink
{
public:
	virtual RxLink *clone() const;
#define RX_PRISMATIC_LINK_ID	2
	static const int ID;

	RxPrismaticLink()
	 { type_ = ID;	   
	 }
	RxPrismaticLink (double d, double theta, double a, double alpha)
	 { type_ = ID;
	   setParams (d, theta, a, alpha);
	 }

	void setJnt (double d);
	void setJnt (const RxVecd &vec, int j=0)
	 { setJnt (vec(j));
	 }

	void getA (RxTrsf *Ap, double d) const;
	const RxTrsf &getA () const
	 { return A_;
	 }

	void getJcol (RxMatd *cols, const RxTrsf &U) const;
	void getJcol (RxMatd *cols, const RxTrsf &U, 
		      double val) const;
	void getJcol (RxMatd *cols, const RxTrsf &U, 
		      const RxVecd &vec, int j=0) const
	 { getJcol (cols, U, vec(j));
	 }

	void addVel (RxTwist *vel, double jvel);
	void addAcc (RxSpatialAccel *acc, const RxTwist &vel,
		     double jvel, double jacc);
};

#endif
