#ifndef _RXREVOLUTELINK_H_WRAP_
#define _RXREVOLUTELINK_H_WRAP_

#include <RxJoint.h>
#include <math.h>

class RxRevoluteJoint : public RxJoint
{
	double theta_;
	double ct, st;

	virtual int oscanField (class RxParseObj *obj);
	virtual int checkFields (class RxParseObj *obj);
	virtual int cprintFields (class RxCoutput *co,class RxPrintSpec *ps,
				  int init=1) const;
	void init();
public:
	static const int ID;
	virtual const char *typeName() const
	 { return "RevoluteJoint";
	 }

	RxRevoluteJoint() : RxJoint(1,1)
	 { init();
	 }
	void setJnt (double theta)
	 { theta_ = theta;
	   ct = cos(theta_);
	   st = sin(theta_);
	 }
	double getJnt () const
	 { return theta_;
	 }
	void setJnt (const RxVecd &vec, int j=0)
	 { theta_ = vec(j);
	   ct = cos(theta_);
	   st = sin(theta_);
	 }
	void getJnt (RxVecd &vec, int j=0) const
	 { vec(j) = theta_;
	 }

	void getTrsf (RxTrsf &T) const;
	void postMulTrsf (RxTrsf &TR, const RxTrsf &T) const;
	void postMulTrsf (RxTrsf &T) const;
	void preMulTrsf (RxTrsf &TR, const RxTrsf &T) const;
	void preMulTrsf (RxTrsf &T) const;
	void addVel (RxTwist &vel) const;
	void addAcc (RxSpatialAccel &acc, const RxTwist &vel0,
				   const RxVecd &jacc, int j=0) const;
	double getJfor (const RxWrench &wr) const;
	void getJfor (RxVecd &jfor, const RxWrench &wr, int j=0) const
	 { jfor(j) = getJfor (wr);
	 }
	void getJcol (RxMatd *cols, const RxTrsf &U, int j=0) const;
};
#endif
