#ifndef _RXREVOLUTELINK_H_WRAP_
#define _RXREVOLUTELINK_H_WRAP_

#include <RxDHLink.h>

class RxRevoluteLink : public RxDHLink
{
public:
	virtual RxLink *clone() const;
#define RX_REVOLUTE_LINK_ID	1
	static const int ID;

	RxRevoluteLink()
	 { type_ = ID;	   
	 }
	RxRevoluteLink (double d, double theta, double a, double alpha)
	 { type_ = ID;
	   setParams (d, theta, a, alpha);
	 }

	void setJnt (double theta);
	void setJnt (const RxVecd &vec, int j=0)
	 { setJnt (vec(j));
	 }

	void getA (RxTrsf *Ap, double theta) const;
	const RxTrsf &getA () const
	 { return A_;
	 }
	void setJnt_ (double theta);
#if 0
	void mulA (RxTrsf *Tp) const;
	void mulA (RxTrsf *Tp, double theta) const;
	void mulA (RxTrsf *Tp, const RxVecd &vec, int j=0) const
	 { mulA (Tp, vec(j));
	 }
	
	void Amul (RxTrsf *Tp) const;
	void Amul (RxTrsf *Tp, double theta) const;
	void Amul (RxTrsf *Tp, const RxVecd &vec, int j=0) const
	 { Amul (Tp, vec(j));
	 }
#endif
	void getJcol (RxMatd *cols, const RxTrsf &U) const;
	void getJcol (RxMatd *cols, const RxTrsf &U, 
		      double val) const;
	void getJcol (RxMatd *cols, const RxTrsf &U, 
		      const RxVecd &vec, int j=0) const
	 { getJcol (cols, U, vec(j));
	 }
	void addVel (RxTwist *vel, double jvel);
	void addAcc (RxSpatialAccel *acc, const RxTwist &vel,
		     double jvel, double jacc);

};
#endif

