#ifndef _RXRIGIDLINK_H_WRAP_
#define _RXRIGIDLINK_H_WRAP_

#include <RxRigidBody.h>
#include <RxJoint.h>
#include <RxDHParams.h>

class RxRigidLink : public RxRigidBody
{
	RxTrsf TL_;
	int dhpSet;
	RxDHParams dhp;

protected:
	RxJoint *joint;
	void init();

	virtual void clearAll();
	virtual int oscanField (class RxParseObj *obj);
	virtual int checkFields (RxParseObj *obj);
	virtual int cprintFields (class RxCoutput *co,class RxPrintSpec *ps,
				  int init=1) const;
public:
	static const int ID;
	static RxRigidLink *findByName(const char *s);

	virtual const char *typeName () const
	 { return "RigidLink";
	 }
	RxRigidLink()
	 { init();
	 }
	RxRigidLink (RxCvxPolyhed3 *poly, RxTrsf *Tp=NULL)
	 { init();
	   setPoly (poly, Tp);
	 }
	RxRigidLink (const RxRigidBody *body, RxTrsf *Tp=NULL)
	 { init();
	   setBody (body, Tp);
	 }

	void setLinkTrsf (const RxTrsf &TL)
	 { TL_ = TL;
	   dhpSet = 0;
	 }
	void getLinkTrsf (RxTrsf &TL) const
	 { TL = TL_;
	 }
	RxTrsf &getLinkTrsf()
	 { return TL_;
	 }
	const RxTrsf &getLinkTrsf() const
	 { return TL_;
	 }

	void setDHParams (double d, double theta, double a, double alpha);
	int getDHParams	(double *dp, double *thetap, 
			 double *ap, double *alphap) const;
	
	void setJoint (RxJoint *jdef)
	 { joint = jdef;	// fix this!!
	 }
	RxJoint *getJoint()
	 { return joint;
	 }
	const RxJoint *getJoint() const
	 { return joint;
	 }

	virtual int setJnts (const RxVecd &vec, int j=0);
	virtual int setJvels (const RxVecd &vec, int j=0);
};

#endif
