#ifndef _RXS3RKIN_H_WRAP_
#define _RXS3RKIN_H_WRAP_

#include <RxGenKin.h>
#include <RxVecd3.h>

#define RX_S3RKIN_SING_ELBOW	 0x0100

#define RX_S3RKIN_CONF_DOWN	 0x0001

#define RX_S3RKIN_CLIP_OUTER	 0x0001
#define RX_S3RKIN_CLIP_INNER	 0x0002

class RxS3RKin : public RxGenKin
{
	void s3Rinit();

	double g10, g1c, g1s;
	double g20, g2c, g2s;
	double g30, g3c, g3s;
	double g40, g4c, g4s;
	double g50, g5c, g5s;

	int setS3RJnts (const RxVecd3 &jnts);
	void setDefaultS3R ();
public:
	RxS3RKin () : RxGenKin()
	 { setDefaultS3R();
	   s3Rinit();
	 }
	RxS3RKin (const char *fileName) : RxGenKin (fileName)
	 { s3Rinit();
	 }
	RxS3RKin (const DHParams *params, int n) : RxGenKin (params, n)
	 { s3Rinit();
	 }
	RxS3RKin (const RxS3RKin &kin) : RxGenKin (kin)
	 { s3Rinit();
	 }
	// inverse kinematics

	int invK (RxVecd *jnts, const RxTrsf &T, int conf, 
			  const RxVecd *jref=NULL, int update=0);

};

#endif
