#ifndef _RXSCALARACCFILTER_H_WRAP_
#define _RXSCALARACCFILTER_H_WRAP_

class RxScalarAccFilter
{
private:
	double x_;
	double v_;
	double a_;
	double A_;
	double V_;

	struct VelProfile {
	  double vp;
	  double ts;
	  };

	void init(double maxv, double maxa);
	VelProfile staticProf (double delx, double td);
	void integrate (const VelProfile &prof, double xd, double tsamp);

public:
	RxScalarAccFilter ()
	 { init(1, 1);
	 }

	RxScalarAccFilter (double maxv, double maxa)
	 { init(maxv, maxa);
	 }

	void step (double xd, double td, double tsamp);

	double x() const
	 { return x_;
	 }
	double &x()
	 { return x_;
	 }
	double v() const
	 { return v_;
	 }
	double &v()
	 { return v_;
	 }
	double a() const
	 { return a_;
	 }
	double &a()
	 { return a_;
	 }
	
	double maxVel() const
	 { return V_;
	 }
	double &maxVel()
	 { return V_;
	 }
	double maxAcc() const
	 { return A_;
	 }
	double &maxAcc()
	 { return A_;
	 }
};


#endif
