#ifndef _RXVECD3ACCFILTER_H_WRAP_
#define _RXVECD3ACCFILTER_H_WRAP_

#include <RxScalarAccFilter.h>
#include <RxVecd3.h>

class RxVecd3AccFilter
{
private:
	RxVecd3 x_;
	RxVecd3 v_;
	RxVecd3 a_;
	RxScalarAccFilter filter1D;

	void init(double maxv, double maxa);
public:
	RxVecd3AccFilter ()
	 { init(1, 1);
	 }

	RxVecd3AccFilter (double maxv, double maxa)
	 { init(maxv, maxa);
	 }

	void step (const RxVecd3 &xd, double td, double tsamp);

	const RxVecd3 &x() const
	 { return x_;
	 }
	RxVecd3 &x()
	 { return x_;
	 }
	const RxVecd3 &v() const
	 { return v_;
	 }
	RxVecd3 &v()
	 { return v_;
	 }
	const RxVecd3 &a() const
	 { return a_;
	 }
	RxVecd3 &a()
	 { return a_;
	 }
	
	double maxVel() const
	 { return filter1D.maxVel();
	 }
	double &maxVel()
	 { return filter1D.maxVel();
	 }
	double maxAcc() const
	 { return filter1D.maxAcc();
	 }
	double &maxAcc()
	 { return filter1D.maxAcc();
	 }
};


#endif
