#ifndef _RXVECTDBASE_H_
#define _RXVECTDBASE_H_

#include <stdio.h>
#include <stdiox.h>
#include <iostream.h>
#include <RxPrintable.h>

class RxVecdBase : public RxPrintable
{
    protected:
	double *v;

	void doAdd(const RxVecdBase &v1, const RxVecdBase &v2, int l);
	void doAdd(const RxVecdBase &v2, int l);
	void doSub(const RxVecdBase &v1, const RxVecdBase &v2, int l);
	void doSub(const RxVecdBase &v2, int l);
	void doExtrap(const RxVecdBase &v1, double a, 
		      const RxVecdBase &v2, int l);
	void doScale(double a, const RxVecdBase &v1, int l);
	void doScale(double a, int l);
	double doDot(const RxVecdBase &v2, int l) const;
	void doUnit(const RxVecdBase &v1, int l);
	void doNeg(const RxVecdBase &v1, int l);
	void doZero(int l);
	double doNorm1(int l) const;
	double doNorm2(int l) const;
	double doNormInf(int l) const;
	void doCopy(const RxVecdBase &v1, int l);

    public:
#if 0
       	RxVecdBase ()
         {
	 }
	RxVecdBase (double *buf)
	 { v = buf;
	 }
#endif
#if 0
	~RxVecdBase () 
	 { };
#endif

	virtual int length() const
	 { return 0;
	 }
	virtual double *buf() const
	 { return 0;
	 }

	virtual RxVecdBase& setArray (double *dp);
	virtual void getArray (double *dp);

	virtual double& operator()(int i)
	 { return v[i]; };
	virtual double operator()(int i) const
	 { return v[i]; };
	virtual double& elem(int i);
	virtual double elem(int i) const;

#if 0
	virtual int scan (FILE *fp=stdin);
	virtual int xscan (FILE *fp);
	virtual int scan (const char *buf, int *cntp=NULL);
	virtual int scan (class RxCinput *ci);
	virtual istream &scan (istream &is);
#endif
	virtual int oscan (class RxParseObj *obj);
	
#if 0
	virtual int print (FILE *fp, const char *fmt) const;
	virtual int print (const char *fmt) const
	 { return this->print(stdout, fmt);
	 }
	virtual int print (char *buf, const char *fmt, int n=0) const;
	virtual ostream &print (ostream &os) const;
#endif
	virtual int cprint (class RxCoutput *co, class RxPrintSpec *fs) const;

	virtual double dot(const RxVecdBase &v2)
	 { return (doDot (v2, length()));
	 }
	virtual double norm1()
	 { return (doNorm1 (length()));
	 }
	virtual double norm2()
	 { return (doNorm2 (length()));
	 }
	virtual double normInf()
	 { return (doNormInf (length()));
	 }

	void neg();

	virtual int equal (const RxVecdBase& v2, double eps) const;
};

inline ostream &operator<<(ostream &os, const RxVecdBase &v)
{
	return v.print(os);
}

inline istream &operator>>(istream &is, RxVecdBase &v)
{
	return v.scan(is);
}

#endif
