#ifndef _RXVRTX3_H_WRAP_
#define _RXVRTX3_H_WRAP_

#include <RxCvxPrim3.h>
#include <RxDistReport3.h>
#include <RxDlist.h>
#include <stdio.h>
#include <iostream.h>

class RxVrtx3 : public RxCvxPrim3
{
	friend class RxCvxPolyhed3;
	friend class RxEdge3;
	friend class PolyTree;

	RxVecd3 q_;
	char *name_;
	class RxSedg3 *sehead;
public:
#define RX_VRTX3_ID	1
	static const int ID;

	RxVrtx3()
	 { type_ = ID;
	   sehead = NULL;
	   name_ = NULL;
	 }
	const char *name() const
	 { return name_;
	 }
	const char *typeName() const
	 { return "Vrtx3";
	 }
	const RxVecd3 &q() const {return q_;}
	int numEdges() const;

#if 0
	RxVrtx3 &xform (const RxVrtx3 &v1, const RxTrsf &T01);
	RxVrtx3 &xform (const RxTrsf &T01)
	 { return xform (*this, T01);
	 }
#endif
	double dist (RxDistRecord3 *rec, RxVrtx3 &v1, const RxTrsf *T01=NULL);

	int scan()
	 { return this->scan(stdin);
	 }
	int scan (FILE *fp);
	int xscan (FILE *fp);
	int scan (const char *buf, int *cntp=NULL);
	int print(const char *fmt) const
	 { return this->print(stdout, fmt);
	 }
	int print(FILE *fp, const char *fmt) const;
	int print(char *buf, const char *fmt) const;
	int print(char *buf, int n, const char *fmt) const;

	ostream &print(ostream &os) const;
	istream &read(istream &is);
};

class RxVrtx3ListNode : public RxDnodeBase
{
public:
	RxVrtx3 v;
	RX_DNODE_DECLS (RxVrtx3ListNode);
};

typedef RxDlist<RxVrtx3ListNode> RxVrtx3List;

inline ostream &operator<<(ostream &os, const RxVrtx3 &v)
{
	return v.print(os);
}

inline istream &operator>>(istream &is, RxVrtx3 &v)
{
	return v.read(is);
}

#endif
