#ifndef _MUTEXDEFS_H_WRAP_
#define _MUTEXDEFS_H_WRAP_

#if defined(_REENTRANT)
#if defined(HAS_POSIX_THREADS)
#include <pthread.h>
#define MUTEX pthread_mutex_t
#define DECLARE_STATIC_MUTEX(m) \
static pthread_mutex_t m = PTHREAD_MUTEX_INITIALIZER;
#define MUTEX_STATIC_INITIALIZER PTHREAD_MUTEX_INITIALIZER
#define MUTEX_INIT(mp) pthread_mutex_init(mp, (pthread_mutexattr_t *)0)
#define MUTEX_LOCK(mp) pthread_mutex_lock (mp)
#define MUTEX_UNLOCK(mp) pthread_mutex_unlock (mp)
#elif defined(HAS_SOLARIS_THREADS)
#include <synch.h>
#define MUTEX mutex_t
#define DECLARE_STATIC_MUTEX(m) static mutex_t m;
#define MUTEX_STATIC_INITIALIZER 0
#define MUTEX_INIT(mp) mutex_init(mp, USYNC_THREAD, (void*)0)
#define MUTEX_LOCK(mp) mutex_lock (mp)
#define MUTEX_UNLOCK(mp) mutex_unlock (mp)
#else
#define MUTEX int
#define DECLARE_STATIC_MUTEX(m)
#define MUTEX_STATIC_INITIALIZER 0
#define MUTEX_INIT(mp)
#define MUTEX_LOCK(mp)
#define MUTEX_UNLOCK(mp)
#endif
#else
#define MUTEX int
#define DECLARE_STATIC_MUTEX(m)
#define MUTEX_STATIC_INITIALIZER 0
#define MUTEX_INIT(mp)
#define MUTEX_LOCK(mp)
#define MUTEX_UNLOCK(mp)
#endif

#endif
