#ifndef _THRDATADEFS_H_WRAP_
#define _THRDATADEFS_H_WRAP_

#if defined(_REENTRANT)
typedef void (*ThrKeyDestructor)(void *);

#if defined(HAS_POSIX_THREADS)
#include <pthread.h>
#define THRDATA_KEY pthread_key_t
#define THRDATA_KEY_CREATE(keyp,destr) pthread_key_create(keyp, destr)
#define THRDATA_SET_DATA(key,val) pthread_setspecific (key, val)
#define THRDATA_GET_DATA(key,val) (val = pthread_getspecific (key))
#define THRDATA_KEY_DELETE(key) pthread_key_delete(key)
#elif defined(HAS_SOLARIS_THREADS)
#include <thread.h>
#define THRDATA_KEY thread_key_t
#define THRDATA_KEY_CREATE(keyp,destr) thr_keycreate(keyp, destr)
#define THRDATA_SET_DATA(key,val) thr_setspecific (key, val)
#define THRDATA_GET_DATA(key,val) thr_getspecific (key, &val)
#define THRDATA_KEY_DELETE(key) 
#else
#define THRDATA_KEY int
#define THRDATA_KEY_CREATE(keyp,destr)
#define THRDATA_SET_DATA(key,val)
#define THRDATA_GET_DATA(key,val)
#define THRDATA_KEY_DELETE(key)
#endif
#else
#define THRDATA_KEY int
#define THRDATA_KEY_CREATE(keyp,destr)
#define THRDATA_SET_DATA(key,val)
#define THRDATA_GET_DATA(key,val)
#define THRDATA_KEY_DELETE(key)
#endif
#endif
