/*---------McGill-Computer-Vision-and-Robotics-Laboratory--C-Module---------
 *		
 * NAME:	useful.h
 *
 * USAGE:	include "/u1/robot/util/useful.h"
 *
 * DESCRIPTION: Contains definitions used in the routines contained in
 *		/u1/robot/util/useful.a
 *
 * NOTES:
 *
 * AUTHOR/DATE:	John Lloyd, September, 1984
 *
 *-------------McGill-Computer-Vision-and-Robotics-Laboratory--------------*/

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <sys/time.h>

#ifndef PROTO
#ifndef NO_PROTOTYPES
#define PROTO(x) x
#else
#define PROTO(x) ()
#endif
#endif

/* definitions for the function cputime */

enum cputime_option
	{ System,		/* Get time used executing system calls */
	  User, 		/* Get time used executing process code */
	  All			/* Get all of the time used by a process */
	};

double cputime PROTO(());
int testchar PROTO((double));
int testc PROTO((FILE*, double));
int testinput PROTO((int, double));
int frandom_seed PROTO((int));
double frandom PROTO((double, double));
double grandom PROTO((double, double));
int irandom PROTO((int, int));
void nap PROTO((double));
int cycleSelect PROTO((int, fd_set*, fd_set*, fd_set*, int*, struct timeval*));
void cycleTimeUpdate PROTO((struct timeval*, int msec));

#ifdef __cplusplus
}
#endif
