#include <RxFastAlloc.h>
#include <mutexdefs.h>
#include <thrdatadefs.h>
#include <cdefs.h>

DECLARE_STATIC_MUTEX(mux)

void RxFastAlloc::initCacheKey (RxFastAllocCache *ck)
{
	MUTEX_LOCK(&mux);
	if (ck->init == 0)
	 { THRDATA_KEY_CREATE (&ck->key, 0);
	   ck->init = 1;
	 }
	MUTEX_UNLOCK(&mux);
}

RxFastAlloc **RxFastAlloc::initCache (RxFastAllocCache *ck)
{
	void *availp = &ck->avail;
	MUTEX_LOCK(&mux);
	THRDATA_GET_DATA (ck->key, availp);
	if (availp == NULL)
	 { availp = new (RxFastAlloc *);
	   *((RxFastAlloc**)availp) = NULL;
       	   THRDATA_SET_DATA (ck->key, availp);
	 }
	MUTEX_UNLOCK(&mux);
	return (RxFastAlloc **)availp;
}

RxFastAlloc **RxFastAlloc::getAvailPtr (RxFastAllocCache *ck)
{
	return (getAvailPtrQ (ck));
}

#if 0
RxFastAlloc *RxFastAlloc::alloc(RxFastAllocCache *ck)
{ 
	RxFastAlloc **availp, *np;

	availp = getAvailPtr (ck);
	if ((np = *availp))
	 { *availp = np->alink;
	   return (np);
	 }
	return NULL;
}

void RxFastAlloc::free (RxFastAllocCache *ck, RxFastAlloc *np)
{
	RxFastAlloc **availp;

	availp = getAvailPtr (ck);
	np->alink = *availp;
	*availp = np;
}
#endif
