#include <RxFastAlloc.h>
#include <RxTimeval.h>
#include <assert.h>
#include <stdio.h>
#include <cdefs.h>

class Foo : public RxFastAlloc
{
	int foo;
public:
	RX_FAST_ALLOC_DECLS(Foo);
	static checkList (int n);
};

RX_FAST_ALLOC_DEFS(Foo);

int Foo::checkList (int n)
{
	Foo *np, *pp;
	int cnt = 0;
	int k;

	for (np=(Foo*)*getAvailPtr(); np; np=(Foo*)np->alink)
	 { for (pp=(Foo*)np->alink; pp; pp=(Foo*)pp->alink)
	    { if (pp == np)
	       { fprintf (stderr, "checkList: repeated element found\n");
		 return 0;
	       }
	    }
	   cnt++;
	 }
	if (cnt != n)
	 { fprintf (stderr, "checkList: n=%d vs. %d\n", cnt, n);
	   return 0;
	 }
	return 1;
}

#define NTRYS	1000000

char **argvec;
main(int argc, char **argv)
{
	Foo *fp;
	Foo *list[100];
	int cnt = 0;

#define DO_ALLOC()	fp = Foo::alloc(); list[cnt++] = fp;
#define DO_FREE()	Foo::free(list[--cnt]);

	volatile Foo *xp;
	int doTiming = 0;
	int i;

	argvec = argv;
	argc--; argv++;
	while (argc > 0)
	 { if (ARGUMENT("-time"))
	    { doTiming = 1;
	    }
	   else
	    { goto usage;
	    }
	   argc--; argv++;
	   continue;
usage:
	   fprintf (stderr, 
"Usage: %s [-time]\n", argvec[0]);
	   exit (1);
	 }

	if (doTiming)
	 { RxFastAlloc **availp;
	   fp = Foo::alloc();
	   Foo::free (fp);
	   TIMEIT ((fp=Foo::alloc(), Foo::free(fp)), NTRYS);
	   TIMEIT (availp = Foo::getAvailPtr(), NTRYS);
	   TIMEIT ((fp=Foo::alloc(availp), Foo::free(availp,fp)), NTRYS);
	   TIMEIT ((fp=new Foo, xp=fp, delete fp), NTRYS);
	 }
	else
	 { 
	   assert (Foo::checkList(0));
	   DO_ALLOC();
	   assert (Foo::checkList(0));
	   DO_ALLOC();
	   assert (Foo::checkList(0));
	   DO_FREE();
	   assert (Foo::checkList(1));
	   DO_FREE();
	   assert (Foo::checkList(2));
	   DO_ALLOC();
	   DO_ALLOC();
	   assert (Foo::checkList(0));
	   DO_ALLOC();
	   DO_ALLOC();
	   DO_ALLOC();
	   assert (Foo::checkList(0));
	   DO_FREE();
	   DO_FREE();
	   assert (Foo::checkList(2));
	   DO_ALLOC();
	   assert (Foo::checkList(1));
	   DO_FREE();
	   DO_FREE();
	   DO_FREE();
	   DO_FREE();
	   assert (Foo::checkList(5));
	   
	   printf ("\nROUTINES OK\n\n");
	 }
}
