#include <RxScanError.h>

RX_ERROR_DEFS_BEGIN(RxScanError)
	   BadInput,  "bad input",
	   BadSyntax, "bad syntax",
	   BadValue,  "bad value",
	   EndOfInput,"end of input",
RX_ERROR_DEFS_END()

RxScanError::RxScanError (int n, const char *fmt, ...) :
	RxError (n)
{
	va_list ap;

	va_start (ap, fmt);
	vset (n, fmt, ap);
	va_end (ap);
	RX_ERROR_CONSTRUCTOR_CODE ();
	lineno_ = 0;
}

RxScanError::RxScanError (int n, int line, const char *fmt, ...) :
	RxError (n)
{
	va_list ap;

	va_start (ap, fmt);
	vset (n, fmt, ap);
	va_end (ap);
	RX_ERROR_CONSTRUCTOR_CODE ();
	lineno_ = line;
}
