#include <RxTimeval.h>

#include <errno.h>
#define _REENTRANT
#if defined(HAS_POSIX_THREADS)
#include <pthread.h>
#endif
#if defined(HAS_SOLARIS_THREADS)
#include <thread.h>
#include <synch.h>
#endif

#define NDATA	100

main()
{
	int err;
	int i;
#if defined(HAS_POSIX_THREADS)
	pthread_t tid;
	pthread_key_t key;
	void *val;

	for (i=0; i<NDATA; i++)
	 { err = pthread_key_create(&key, 0);
	   if (err)
	    { errno = err;
	      perror ("pthread_key_create");
	      exit (1);
	    }
	   err = pthread_setspecific (key, &err);
	   if (err)
	    { errno = err;
	      perror ("pthread_setspecific");
	      exit (1);
	    }
	   if (pthread_getspecific (key) != &err)
	    { fprintf (stderr, "(pthread_getspecific returns %x vs. %x\n", 
		      pthread_getspecific (key), &err);
	      exit (1);
	    }
	 }
	TIMEIT(tid=pthread_self(), 1000);
	TIMEIT(err=pthread_setspecific (key, &err), 1000);
	TIMEIT(val=pthread_getspecific (key), 1000);
#endif
#if defined(HAS_SOLARIS_THREADS)
	thread_t tid;
	thread_key_t key;
	void *val;

	for (i=0; i<NDATA; i++)
	 {
	   err = thr_keycreate(&key, 0);
	   if (err)
	    { errno = err;
	      perror ("thr_keycreate");
	      exit (1);
	    }
	   err = thr_setspecific (key, &err);
	   if (err)
	    { errno = err;
	      perror ("thr_setspecific");
	      exit (1);
	    }
	   val = 0xdeadbeef;
	   err = thr_getspecific (key, &val);
	   if (val != &err)
	    { fprintf (stderr, "(thr_getspecific returns %x vs. %x\n", 
		      val, &err);
	      exit (1);
	    }
	 }
	TIMEIT(tid=thr_self(), 1000);
	TIMEIT(err=thr_setspecific (key, &err), 1000);
	TIMEIT(err=thr_getspecific (key, &val), 1000);

#endif
#if !defined(HAS_POSIX_THREADS) && !defined(HAS_SOLARIS_THREADS)
	printf ("No thread support specified for this system\n");
#endif
}
