#include <RxTimeval.h>
#include <fastmath.h>

#include <stdio.h>
#include <cdefs.h>
#include <stdlib.h>

/* 1.5e-14 */

char **argvec;

int interactive = 0;

#define NRANDOM	10000
#define TEST_RNG	20

int checkError (double *maxerrp, double a1, double a2)
{
	if (ABS(a1-a2) > *maxerrp)
	 { *maxerrp = ABS(a1-a2);
	   return 1;
	 }
	else
	 { return 0;
	 }
}

main(int argc, char **argv)
{
	double cnt= 100000;
	double err, maxerr;
	double a;
	double x;
	double y;
	int i;

	argvec = argv;
	argc--; argv++;
	while (argc > 0)
	 { if (ARGUMENT("-i"))
	    { interactive = 1;
	    }
	   else
	    { goto usage;
	    }
	   argc--; argv++;
	   continue;
usage:
	   fprintf (stderr, 
"Usage: %s [-i]\n", argvec[0]);
	   exit (1);
	 }

	if (interactive)
	 { while (1)
	    { printf ("> ");
	      scanf ("%lf%lf", &y, &x);
	      printf ("ATAN2(y,x)=%19.16f\n", ATAN2(y,x));
	      printf ("atan2(y,x)=%19.16f\n", atan2(y,x));
	    }
	 }
	else
	 {
	   maxerr = 0;
	   for (i=-ATAN2_TAB_SIZE; i<ATAN2_TAB_SIZE+2; i++)
	    { y = i/ATAN2_TAB_SCALE;
	      x = 1.0;
	      checkError (&maxerr, atan2(y,x), ATAN2(y,x));
#if 0
	      checkError (&maxerr, atan2(x,y), ATAN2(x,y));
	      checkError (&maxerr, atan2(y,-x), ATAN2(y,-x));
	      checkError (&maxerr, atan2(-x,y), ATAN2(-x,y));
	      checkError (&maxerr, atan2(-y,-x), ATAN2(-y,-x));
	      checkError (&maxerr, atan2(-x,-y), ATAN2(-x,-y));
	      checkError (&maxerr, atan2(-y,x), ATAN2(-y,x));
	      checkError (&maxerr, atan2(x,-y), ATAN2(x,-y));
#endif
	      y = (i+0.5)/ATAN2_TAB_SCALE;
	      x = 1.0;

	      checkError (&maxerr, atan2(y,x), ATAN2(y,x));
	      checkError (&maxerr, atan2(y,-x), ATAN2(y,-x));
	      checkError (&maxerr, atan2(-x,y), ATAN2(-x,y));

	      checkError (&maxerr, atan2(-y,-x), ATAN2(-y,-x));

	      checkError (&maxerr, atan2(-x,-y), ATAN2(-x,-y));

	      checkError (&maxerr, atan2(-y,x), ATAN2(-y,x));

	      checkError (&maxerr, atan2(x,-y), ATAN2(x,-y));
	    }
#if 1
	   for (i=0; i<NRANDOM; i++)
	    { x = 2*TEST_RNG*(drand48()-0.5);
	      y = 2*TEST_RNG*(drand48()-0.5);
	      if (checkError (&maxerr, atan2(y,x), ATAN2(y,x)))
	       {printf ("y, x = %g %g\n", y, x);
	       }
	    }
#endif
	   printf ("max ATAN2 error = %g\n", maxerr);
	   
	   TIMEIT (a = ATAN2(12,-1), cnt);
	   TIMEIT (a = atan2(12,-1), cnt);
	 }
}
