#ifndef _GRF4SUPPORT_H_WRAP_
#define _GRF4SUPPORT_H_WRAP_

#ifdef __cplusplus
extern "C"
{
#endif

TRSF *identTrsf (TRSF *tr);
TRSF *xyzToTrsf (TRSF *tr, double x, double y, double z);
TRSF *multTrsfXyz (TRSF *tr, double x, double y, double z);
TRSF *axesToTrsf (TRSF *tr, char *axes, VECT *v1, VECT *v2);
TRSF *multTrsfAxes (TRSF *tr, char *axes, VECT *v1, VECT *v2);
TRSF *rpyToTrsf(TRSF *tr, double roll, double pitch, double yaw);
void trsfToRpy (double *roll, double *pitch, double *yaw, TRSF *tr);
TRSF *multTrsfRpy(TRSF *tr, double roll, double pitch, double yaw);
TRSF *multTrsf(TRSF *r, const TRSF *t1, const TRSF *t2);
TRSF *invertTrsf(TRSF *i, TRSF *t);
TRSF *multLiTrsf (TRSF *r, const TRSF *t1, const TRSF *t2);
TRSF *multRiTrsf (TRSF *r, const TRSF *t1, const TRSF *t2);
void printTrsf (const char *fmt, TRSF *T);
VECT *zeroVect(VECT *vr);
double dotVect(VECT *v1, VECT *v2);
VECT *transVect(VECT *vr, VECT *v1, TRSF *T);
VECT *invTransVect(VECT *vr, VECT *v1, TRSF *T);
VECT *rotateVect(VECT *vr, VECT *v1, TRSF *T);
VECT *invRotateVect(VECT *vr, VECT *v1, TRSF *T);
VECT *addVect(VECT *vr, VECT *v1, VECT *v2);
VECT *subtractVect(VECT *vr, VECT *v1, VECT *v2);
VECT *scaleVect(VECT *vr, double a, VECT *v1);
VECT *combineVect (VECT *vr, double a, VECT *v1, double b, VECT *v2);
VECT *unitVect(VECT *vr, VECT *v1);
double norm2Vect(VECT *v1);
void trsfToRot (VECT *v, double *h, TRSF *t1);
TRSF *rotToTrsf(TRSF *tr, VECT *v, double h);
TRSF *multTrsfRot(TRSF *tr, VECT *v, double h);
VECT *crossVect(VECT *vr, VECT *v1, VECT *v2);

#ifdef __cplusplus
}
#endif

#endif
