#ifdef HAS_GL_WINDOWS

#include <grf4.h>
#include "grf4Internal.h"
#include "grf4Support.h"
#include "grf4GlCommon.h"
#include "grf4glObject.h"
#include <RxCvxPolyhed3.h>
#include <gl/gl.h>

extern TRSF* iGLTransPtr;
extern int iGLPerspectiveMode;

static TRSF Identity = { 1.0, 0.0, 0.0,
			 0.0, 1.0, 0.0,
			 0.0, 0.0, 1.0,
			 0.0, 0.0, 0.0 };

static void Vecd3ToV3f (float *fp, const RxVecd3 &vec)
{
	fp[0] = vec.x();
	fp[1] = vec.y();
	fp[2] = vec.z();
}

static float _v3f[3];
#define V3F(x,y,z)	(_v3f[0]=(x), _v3f[1]=(y), _v3f[2]=(z), v3f(_v3f))

void iglDrawPolyhed3 (void *ptr)
{
	RxCvxPolyhed3 *poly = (RxCvxPolyhed3 *)ptr;
	const RxFace3ListNode *fnode;
	const RxSedg3 *se;
	TRSF *T;
	float nrml0[3];
	float nrml[3];
	float vpnt[3];
	int visible;

	T = (iGLTransPtr ? iGLTransPtr : &Identity);

	for (fnode=poly->faces().head(); fnode; fnode=fnode->next())
	 { 
	   Vecd3ToV3f (nrml0, fnode->f.plane.n());
	   _grf4MultRotV3f (nrml, T, nrml0);
	   if (!iGLPerspectiveMode)
	    { visible = (nrml[2] > 0.0);
	    }
	   else
	    { Vecd3ToV3f (vpnt, fnode->f.selist.head()->vrtx()->q());
	      _grf4MultTrsfV3f (vpnt, T, vpnt);
	      visible = (_grf4DotV3f (vpnt, nrml) < 0.0);
	    }
	   if (visible)
	    { 
	      bgnpolygon();
	      n3f (nrml0);
	      se=fnode->f.selist.head();
	      do
	       { const RxVecd3 &q = se->vrtx()->q();
		 V3F (q.x(), q.y(), q.z());
		 se=se->next();
	       }
	      while (se != fnode->f.selist.head());
	      endpolygon();
	    }
	 }
}

#endif
