#include <RxMatdChol.h>
#include <RxTimeval.h>
#include <cdefs.h>

#define MAXD	9
#define EPS	(1e-10)

main()
{
	double det;
	int ii, jj;
	int i, j;

	double buf[MAXD*MAXD] = {  
			    1, 2, 6, 4, 5, 6, 7, 0, 0,
			    6, 5, 4, 3, 2, 1, 0, 0, 0,
			    1, 2, 1, 2, 1, 2, 1, 0, 1,
			    1, 1, 1, 9, 1, 1, 1, 0, 9,
			    1, 3, 2, 5, 4, 9, 6, 0, 8,
			    8, 8, 7, 7, 2, 5, 4, 1, 5,
			    4, 3, 5, 6, 7, 5, 4, 1, 6,
			    0, 0, 0, 0, 1, 1, 1, 1, 7,
			    1, 3, 3, 7, 8, 1, 2, 8, 13 };

	int n = 6;

	for (n=1; n<=MAXD; n++)
	 { for (ii=0; ii<=MAXD-n; ii++)
	    { for (jj=0; jj<=MAXD-n; jj++)
	       { RxMatd B(n, n, &buf[ii*MAXD+jj], MAXD);
		 RxMatd A(n,n);
		 RxMatd L(n,n);
		 RxMatd I(n,n);

		 // make sure matrix is symmetric positive definite
		 A = B * B.T();
		 for (i=0; i<n; i++)
		  { if (A(i,i) < EPS)
		     { A(i,i) = 1;
		     }
		  }
		 RxMatdChol chol(A);
		 chol.copyL (&L);

		 if (!A.equal (L*L.T(), EPS))
		  { fprintf (stderr, "A != L L', n=%d ii=%d jj=%d\n",
				      n, ii, jj);
		    L.print ("L"); 
		    A.print ("A");
		    exit (1);
		  }
		 if (n <= 3)
		  { if (n == 1)
		     { det = A(0,0);
		     }
		    else if (n == 2)
		     { det = A(0,0)*A(1,1) - A(0,1)*A(1,0);
		     }
		    else if (n == 3)
		     { det = A(0,0)*A(1,1)*A(2,2) + 
			     A(0,1)*A(1,2)*A(2,0) + 
			     A(0,2)*A(1,0)*A(2,1) -
			     A(0,2)*A(1,1)*A(2,0) -
			     A(0,0)*A(1,2)*A(2,1) -
			     A(0,1)*A(1,0)*A(2,2);
		     }
		    if (ABS(det-chol.det()) > sqrt(EPS))
		     { fprintf (stderr, 
"det=%g vs. %g n=%d ii=%d jj=%d\n", chol.det(), det, n, ii, jj);
		       L.print ("L"); 
		       exit (1);	       
		     }
		  }
		 if (chol.condest(A) < 1/EPS)
		  { RxMatd Itest(n,n);
		    RxVecd b(n);
		    RxVecd x(n);
		    b.set (buf);

		    chol.solve (&x, b);
		    if (!(A*x).equal (b, EPS))
		     { fprintf (stderr, "A*x != b, n=%d ii=%d jj=%d\n",
				      n, ii, jj);
		       
		       L.print ("L"); 
		       b.print ("b%8.4f\n");
		       x.print ("x%8.4f\n");
		       (A*x).print ("A*x%8.4f\n");
		       exit (1);
		     }

		    Itest.setIdent();

		    for (j=0; j<n; j++)
		     { for (i=0; i<n; i++)
			{ b(i) = (i==j ? 1.0 : 0.0);
			}
		       chol.solve (&x, b);
		       for (i=0; i<n; i++)
			{ I(i,j) = x(i);
			}
		     }
		    if (!(I*A).equal (Itest, EPS))
		     { fprintf (stderr, 
"(1) A*A.inv() != I, n=%d ii=%d jj=%d\n", n, ii, jj);
		       I.print ("I");
		       A.print ("A");
		       L.print ("L"); 
		       exit (1);
		     }
		    chol.inv(&I);
		    if (!(I*A).equal (Itest, EPS))
		     { fprintf (stderr, 
"(2) A*A.inv() != I, n=%d ii=%d jj=%d\n", n, ii, jj);
		       I.print ("I");
		       A.print ("A");
		       L.print ("L"); 
		       exit (1);
		     }
		    
		  }
	       }
	    }
	 }
	printf ("\nROUTINES OK\n\n");
	exit (0);
}
