#ifndef _RXMATDLU_H_WRAP_
#define _RXMATDLU_H_WRAP_

#include <RxMatd.h>

#define RX_LU_DEFAULT_EPS	(1e-13)

class RxMatdLu
{
	friend class RxMatd;

	void doLu (const RxMatd &A);

	double tol;
#define RX_LU_CALCDONE		0x01
#define RX_LU_LU_MALLOCED	0x02
#define RX_LU_PERM_MALLOCED	0x04
#define RX_LU_SINGULAR		0x08
	int flags;
	int n;

	RxMatd *LU;
	int *perm;
public:
	// initialization

	int calc (const RxMatd &A);
	int setLUP (RxMatd *Lu, int *pv);

	void setTol (double eps)
	 { tol = eps;
	 }
	void getLUP (RxMatd **Lu, int **pv)
	 { *Lu = LU;
	   *pv = perm;
	 }
	RxMatd *getLU()
	 { return (LU);
	 }
	int *getPerm()
	 { return (perm);
	 }
	double getTol () const
	 { return (tol);
	 }
	void copyLUP (RxMatd *L, RxMatd *U, RxMatd *P) const;

	// constructors 

	RxMatdLu ()
	 { perm = 0;
	   LU = NULL;
	   tol = RX_LU_DEFAULT_EPS;
	   flags = 0;
	 }
	RxMatdLu (const RxMatd &A, RxMatd *Lu=NULL, int *pv=NULL,
		  double eps=RX_LU_DEFAULT_EPS)
	 { perm = 0;
	   LU = NULL;
	   flags = 0;
	   setLUP (Lu, pv);
	   tol = eps;
	   calc (A);
	 }
	~RxMatdLu ();

	RxVecd &solve (RxVecd *x, const RxVecd &b) const;
	RxVecd &Tsolve (RxVecd *x, const RxVecd &b) const;
	RxMatd &solve (RxMatd *X, const RxMatd &B) const;
	double condest(const RxMatd &A) const;
	double det() const;

	RxMatd &inv (RxMatd *M) const;
};

#endif
