#include <RxMatdLu.h>
#include <RxTimeval.h>
#include <cdefs.h>

#define MAXD	9
#define EPS	(1e-10)

main()
{
	double det;
	int ii, jj;
	int i, j;

	double buf[MAXD*MAXD] = {  
			    1, 2, 6, 4, 5, 6, 7, 0, 0,
			    6, 5, 4, 3, 2, 1, 0, 0, 0,
			    1, 2, 1, 2, 1, 2, 1, 0, 1,
			    1, 1, 1, 9, 1, 1, 1, 0, 9,
			    1, 3, 2, 5, 4, 9, 6, 0, 8,
			    8, 8, 7, 7, 2, 5, 4, 1, 5,
			    4, 3, 5, 6, 7, 5, 4, 1, 6,
			    0, 0, 0, 0, 1, 1, 1, 1, 7,
			    1, 3, 3, 7, 8, 1, 2, 8, 13 };

	int n = 6;

	for (n=1; n<=MAXD; n++)
	 { for (ii=0; ii<=MAXD-n; ii++)
	    { for (jj=0; jj<=MAXD-n; jj++)
	       { RxMatd A(n, n, &buf[ii*MAXD+jj], MAXD);
		 RxMatd L(n,n);
		 RxMatd U(n,n);
		 RxMatd P(n,n);
		 RxMatd I(n,n);

		 RxMatdLu lu(A);

		 lu.copyLUP (&L, &U, &P);

		 if (!A.equal (P.T()*L*U, EPS))
		  { fprintf (stderr, "A != P' L U, n=%d ii=%d jj=%d\n",
				      n, ii, jj);
		    P.print ("P"); 
		    L.print ("L"); 
		    U.print ("U");
		    exit (1);
		  }
		 if (n <= 3)
		  { if (n == 1)
		     { det = A(0,0);
		     }
		    else if (n == 2)
		     { det = A(0,0)*A(1,1) - A(0,1)*A(1,0);
		     }
		    else if (n == 3)
		     { det = A(0,0)*A(1,1)*A(2,2) + 
			     A(0,1)*A(1,2)*A(2,0) + 
			     A(0,2)*A(1,0)*A(2,1) -
			     A(0,2)*A(1,1)*A(2,0) -
			     A(0,0)*A(1,2)*A(2,1) -
			     A(0,1)*A(1,0)*A(2,2);
		     }
		    if (ABS(det-lu.det()) > EPS)
		     { fprintf (stderr, 
"det=%g vs. %g n=%d ii=%d jj=%d\n", lu.det(), det, n, ii, jj);
		       P.print ("P"); 
		       L.print ("L"); 
		       U.print ("U");
		       exit (1);	       
		     }
		  }
		 if (lu.condest(A) < 1/EPS)
		  { RxMatd Itest(n,n);
		    RxVecd b(n);
		    RxVecd x(n);

		    Itest.setIdent();
		    lu.inv(&I);
		    if (!(I*A).equal (Itest, EPS))
		     { fprintf (stderr, "A*A.inv() != I, n=%d ii=%d jj=%d\n",
				      n, ii, jj);
		       P.print ("P"); 
		       L.print ("L"); 
		       U.print ("U");
		       I.print ("I");
		       exit (1);
		     }
		    b.set (buf);

		    lu.solve (&x, b);
		    if (!(A*x).equal (b, EPS))
		     { fprintf (stderr, "A*x != b, n=%d ii=%d jj=%d\n",
				      n, ii, jj);
		       
		       P.print ("P"); 
		       L.print ("L"); 
		       U.print ("U");
		       b.print ("b%8.4f\n");
		       x.print ("x%8.4f\n");
		       (A*x).print ("A*x%8.4f\n");
		       exit (1);
		     }
		    lu.Tsolve (&x, b);
		    if (!(x*A).equal (b, EPS))
		     { fprintf (stderr, "x*A != b, n=%d ii=%d jj=%d\n",
				      n, ii, jj);
		       
		       P.print ("P"); 
		       L.print ("L"); 
		       U.print ("U");
		       b.print ("b%8.4f\n");
		       x.print ("x%8.4f\n");
		       (x*A).print ("x*A%8.4f\n");
		       exit (1);
		     }
		  }
	       }
	    }
	 }
	printf ("\nROUTINES OK\n\n");
	exit (0);
#if 0
	RxMatd A(buf,n,n);
	RxMatd L(n,n);
	A.print ("A  = [%9.5f]\n");
	lu.copyLU (&L, &U);
	L.print ("L  = [%9.5f]\n");
	U.print ("U  = [%9.5f]\n");
	(L*U).print ("L*U=[%9.5f]\n");
	lu.inv(&I).print ("I  = [%9.5f]\n");
	(I*A).print ("I*A= [%9.5f]\n");

	RxVecd b(buf, n);
	RxVecd x(n);

	I.setIdent();

	for (j=0; j<n; j++)
	 { b = I(0,j,n,1);
	   lu.solve (&x, b);
	   I(0,j,n,1) = x;
	 }
	(I*A).print ("I*A= [%9.5f]\n");

	printf ("lu.condest(A) = %g\n", lu.condest(A));	
	
	I.setIdent();

	lu.calc (I);
	printf ("lu.condest(I) = %g\n", lu.condest(I));

	TIMEIT (lu.condest(A), 1000);
	TIMEIT (lu.inv(&I), 1000);
#endif
}
