#include <RxVecd.h>
#include <RxTimeval.h>
#include <cdefs.h>

#define LEN	6

main()
{
	int cnt = 1000;
	RxVecd v1(LEN);
	RxVecd v2(LEN);
	RxVecd v3(LEN);
	double a = 11;
	volatile double r;
	int i;

	for (i=0; i<LEN; i++)
	 { v1(i) = i+1;
	   v2(i) = (i+1)*10;
	 }

	/* do a trial run and boast cnt if necessary */
	 { RxTimeval t0, t1;
	   int i;

	   t0.sysSetTod();
	   for (i=0; i<cnt; i++)
	    { v1+v2;
	    }
	   t1.sysSetTod();
	   if ((double)(t1-t0) < 0.1)
	    { cnt = (int)(cnt*0.1/(double)(t1-t0));
	    }
	 }
	printf ("using an iteration count of %d:\n", cnt);

	TIMEIT (v3=v1, cnt);
	TIMEIT (v1+v2, cnt);
	TIMEIT (v3.add(v1,v2), cnt);
	v3 = v1;
	TIMEIT (v3.add(v2), cnt);
	v3 = v1;
	TIMEIT (v3 += v2, cnt);
	
	printf ("\n");

	TIMEIT (v1*a, cnt);
	TIMEIT (v3.scale(a,v1), cnt);
	v3 = v1;
	TIMEIT (v3.scale(a), cnt);
	v3 = v1;
	TIMEIT (v3 *= a, cnt);

	printf ("\n");

	TIMEIT (r = v1.dot(v2), cnt);
}
