#ifndef _RXPARSELEX_H_WRAP_
#define _RXPARSELEX_H_WRAP_

#include <RxCio.h>
#include <RxParseObj.h>
#include <RxSysError.h>

typedef struct {
	RxParseObj *node;
	union {
	    double d;
	    int i;
	    char* s;
	 } u;
	char *s_raw;
	int lineno;
} ParseLexType;

#define YYSTYPE ParseLexType

typedef struct
{
	RxCinput *cinp;
	class RxParseObj *node;
	RxSysError *errp;
	int lineno;
	int level;
	int debug;
	int eof;
} ParseArg;

#define YYPARSE_PARAM	yyarg
#define YYARG		((ParseArg*)yyarg)
#define YYLEX_PARAM	YYARG

int rxParseLexer(YYSTYPE *yylvalp, ParseArg *lexarg);
#define yylex rxParseLexer

static char* tokenToStr(int token);
static int strToToken (char *str);

#endif
