#ifndef _POSTSCRIPT_H_
#define _POSTSCRIPT_H_

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

#define PPI		72		/* PointsPerInch */
#define PAGE_WIDTH	(8.5*PPI)	/* typical page length */
#define PAGE_LENGTH	(11*PPI)	/* typical page width */
#define MIN_PLOT_HEIGHT	(PPI)

#ifndef PROTO
#ifndef NO_PROTOTYPES
#define PROTO(x) x
#else
#define PROTO(x) ()
#endif
#endif

void psFileSet PROTO((FILE*));       
void psMoveto PROTO((double, double));
void psLineto PROTO((double, double));
void psCircle PROTO((double, double, double));
void psLineSeg PROTO((double, double, double, double));
void psPutStrR PROTO((char*, double, double));
void psPutStrL PROTO((char*, double, double));
void psFont PROTO((double, char*));
void psTranslate PROTO((double, double));
void psNewpath PROTO(());
void psStroke PROTO(());
void psShowpage PROTO(());
void psPathdot PROTO((double, double, double, double));
void psSetlinewidth PROTO((double));
void psSetclipBox PROTO((double, double, double, double));
void psCommand PROTO((char*));

#define IDRAW_WIDTH_1	1
#define IDRAW_WIDTH_2	2
#define IDRAW_WIDTH_3	3

#define IDRAW_PAT_NONE	0
#define IDRAW_PAT_BLACK	1
#define IDRAW_PAT_WHITE	2
#define IDRAW_PAT_3	3
#define IDRAW_PAT_4	4
#define IDRAW_PAT_5	5
#define IDRAW_PAT_6	6
#define IDRAW_PAT_7	7
#define IDRAW_PAT_8	8
#define IDRAW_PAT_9	9
#define IDRAW_PAT_10	10
#define IDRAW_PAT_11	11
#define IDRAW_PAT_12	12
#define IDRAW_PAT_13	13

#define IDRAW_SOLID	0
#define IDRAW_DASH_1	1
#define IDRAW_DASH_2	2
#define IDRAW_DASH_3	3

void IdrawInit PROTO((FILE*));
void IdrawBaseTrans PROTO((double, double));
void IdrawBaseSet PROTO((double, double));
void IdrawScaleSet PROTO((double, double));
int IdrawLineWidth PROTO((int));
int IdrawDashes PROTO((int));
void IdrawMove PROTO((double, double));
void IdrawCircle PROTO((double, int));
void IdrawEllipse PROTO((double, double, int));
void IdrawLine PROTO((double, double));
void IdrawArrowLine PROTO((double, double));
void IdrawLineSeg PROTO((double, double, double, double));
void IdrawMlineBegin PROTO((int));
void IdrawMlinePut PROTO((double, double));
void IdrawMlineEnd PROTO(());
void IdrawClose PROTO(());
void IdrawSave PROTO(());
void IdrawRestore PROTO(());

#ifdef __cplusplus
}
#endif

#endif
